<?php
/*
Plugin Name: Content Spinner Wiz
Plugin URI: http://onlinesuccesswithchris.com/
Description: Content Spinner Wiz helps you spin articles for your WordPress Blog or Site. | <a href="../wp-content/plugins/content-spinner-wiz/Content-Spinner-Wiz_UserManual_v2.4.pdf" title="Content Spinner Wiz User Manual" target="_blank">PDF User Manual</a> | <a href="../wp-content/plugins/content-spinner-wiz/Content-Spinner-Wiz_readme_v2.4.txt" title="Content Spinner Wiz Readme Text File" target="_blank">Readme File</a> |
Version: 2.5
Author: Chris Jenkins
Author URI: http://onlinesuccesswithchris.com/
*/
$path = dirname(__FILE__);
$position = STRRPOS($path,'/') + 1;
$dir_name = substr($path,$position);
define(PG_CONTENTSPINNER_PLUGIN_FOLDER,'/'.$dir_name.'/');
define( PG_CONTENTSPINNER_PLUGIN_URL , WP_PLUGIN_URL.PG_CONTENTSPINNER_PLUGIN_FOLDER);
define( PG_CONTENTSPINNER_PLUGIN_DIR, WP_PLUGIN_DIR.PG_CONTENTSPINNER_PLUGIN_FOLDER);
include "lang/lang_en.php";

function pg_contentspinner_activate() {

    add_option('pgsc_form_label_limit','Limit Output');
    add_option('pgsc_form_label_article','Article');  
    add_option('pgsc_form_files_file_prefix','articles'); 
    add_option('pgsc_system_save_articles',0);
    add_option('pgsc_system_max_output','5000');
    add_option('pgsc_system_delzip_timestamp','-1hour');
    include "sql/install.php";
}

function pg_contentspinner_deactivate() {
    delete_option('pgsc_form_label_limit');
    delete_option('pgsc_form_label_article');  
    delete_option('pgsc_form_files_file_prefix'); 
    delete_option('pgsc_system_save_articles');
    delete_option('pgsc_system_max_output');
    delete_option('pgsc_system_delzip_timestamp');
    include "sql/uninstall.php";
   
}
register_activation_hook(__FILE__, 'pg_contentspinner_activate');  // WordPress Hook that executes  installation
register_deactivation_hook(__FILE__, 'pg_contentspinner_deactivate');  // WordPress Hook that executes remove installation


function pg_contentspinner_ini_admin_menu() {
	add_menu_page(PG_CONTENTSPINNER_PLUGIN_TITLE, PG_CONTENTSPINNER_PLUGIN_TITLE, 'administrator', 'pg_contentspinner-admin', 'pg_contentspinner_admin',PG_CONTENTSPINNER_PLUGIN_URL.'icon.png');
        add_submenu_page('pg_contentspinner-admin', PG_CONTENTSPINNER_SMENU_SAVED_ARTICLES, PG_CONTENTSPINNER_SMENU_SAVED_ARTICLES, 'administrator', 'pg_contentspinner-saved_articles', 'pg_contentspinner_saved_articles');
        
}

function pg_contentspinner_admin(){
    
    include "ui/main.php";
    
}


function pg_contentspinner_saved_articles(){
    
    include "ui/listing.php";
    
}

add_action('admin_menu', 'pg_contentspinner_ini_admin_menu'); 


add_shortcode('contentspinnerform','pg_content_spinner_sc');
function pg_content_spinner_sc(){
    __pgsc_load_assets();
           
     
    $html = "
        <form method='post' id='__pgcsform' action='".admin_url('admin-ajax.php')."'>
            <input type='hidden' name='action' value='pgcsform_handler'>
            
            <table>
                <tr>
                    <td>". get_option('pgsc_form_label_limit'). "</td>
                    <td><input type='text' name='limit_output' size='4'></td>
                </tr>
                 <tr>
                    <td style='vertical-align:top'>".get_option('pgsc_form_label_article')."</td>
                    <td><textarea name='article' style='width: 426px; height: 369px;'></textarea></td>
                </tr>
                 <tr>
                    <td colspan='2'><input type='submit' value='Start Spinning!'></td>
                </tr>
            </table>
        </form>
       
        ";
    return $html;
}

function __pgsc_load_assets(){
    
    wp_enqueue_script('jquery');
    wp_register_script('js-ajax-contentspinner',PG_CONTENTSPINNER_PLUGIN_URL.'assets/js/__jscs.js');
    wp_enqueue_script('js-ajax-contentspinner');
}

add_action('wp_ajax_pg_cs_update_settings','pg_cs_update_settings');

function pg_cs_update_settings(){
    
    update_option('pgsc_form_label_limit',$_POST['pgsc_form_label_limit']);
    update_option('pgsc_form_label_article',$_POST['pgsc_form_label_article']);  
    update_option('pgsc_form_files_file_prefix',$_POST['pgsc_form_files_file_prefix']);  
    update_option('pgsc_system_save_articles',$_POST['pgsc_system_save_articles']);
    update_option('pgsc_system_max_output',$_POST['pgsc_system_max_output']);
    update_option('pgsc_system_delzip_timestamp',$_POST['pgsc_system_delzip_timestamp']);
    die(' Options Updated');
    
}
add_action('wp_ajax_pg_cs_show_original','pg_cs_show_original');
function pg_cs_show_original(){
    global $wpdb;
    
        $original_text = $wpdb->get_var($wpdb->prepare("SELECT original FROM ".$wpdb->prefix."pgcs_saved_articles WHERE id=".(int)$_POST['id']) );
        if($_POST['mode'] == "admin") die(nl2br(stripslashes($original_text) ));
    $html = "<h3>Showing Original Article for ID#:{$_POST['id']}</h3>";
    $html .= "<p>".nl2br(stripslashes($original_text) )."</p>";
    die($html);
}

add_action('wp_ajax_pg_cs_show_spinned','pg_cs_show_spinned');
function pg_cs_show_spinned(){
    global $wpdb;
    
    $spinned = json_decode( $wpdb->get_var($wpdb->prepare("SELECT spinned FROM ".$wpdb->prefix."pgcs_saved_articles WHERE id=".(int)$_POST['id']) ) );
        
    $html = "<h3>Showing Spinned Article(s) for ID#:{$_POST['id']}</h3>";
    
    foreach($spinned as $id=>$spin){
        $index = $id + 1;
        $html .="<p>Count # : $index <br> ".nl2br(stripslashes($spin))."</p>";
    }
   
    die($html);
}

add_action('wp_ajax_pg_cs_sa_paginate','pg_cs_sa_paginate');

function pg_cs_sa_paginate(){
 global $wpdb;
    include PG_CONTENTSPINNER_PLUGIN_DIR."libraries/Pagination.php";
    $pagination = new Pagination();
    $pagination->ajax_links = TRUE;
    $pagination->setLink("%s");
    $pagination->setPage($_POST['page']);
    $pagination->setSize(10);
    $pagination->setTotalRecords( $wpdb->get_var($wpdb->prepare('SELECT count(*) as num FROM '.$wpdb->prefix.'pgcs_saved_articles')));           
    $articles = $wpdb->get_results("SELECT id,original,remote_addr,date_created,process_time FROM ".$wpdb->prefix."pgcs_saved_articles ORDER BY ID DESC ".$pagination->getLimitSql() );    
    echo $pagination->create_links();
    ?>
    <table border="1" class="widefat">
	<thead>
		<tr>
			<th style="padding-left:10px;" class="check-column">ID</th>
			<th>Original Text</th>
			<th>Results</th>
			<th>Processsing Time (sec)</th>
			<th>Requested By</th>
			<th>Date Requested</th>
		</tr>
	</thead>
        <tbody id="the-liast">
              
	<?php
                foreach($articles as $article ): 
        ?>
		
			<tr class="alternate author-self status-inherit"> 							
				<th><?php echo $article->id?></th>
				<th><a href='javascript:showOriginal(<?php echo $article->id ?>)'>Show Original</a></th>
                                <th><a href='javascript:showSpinned(<?php echo $article->id ?>)'>Show Results</a></th>
				<th><?php echo $article->process_time?>sec(s)</th>
				<th><?php echo $article->remote_addr?></th>
				<td><?php echo date("F d Y h:i:s a",$article->date_created )?></td>
			
			</tr>
		
	<?php endforeach;?>
	<?php if( empty($articles) ) :?>
		
				<tr>
					<td colspan="7" align="center"> <strong>No results  <?php if(get_option('pgsc_system_save_articles') == 0 ) : ?>-  if you want to enable this feature, check the option named "System - Save Spinned Articles" on the plugin main page.<?php endif;?> </strong> </td>
				</tr>
									
	<?php endif;?>
         </tbody>       
	<thead>
		<tr>
			<th style="padding-left:10px;" class="check-column">ID</th>
			<th>Original Text</th>
			<th>Results</th>
			<th>Processsing Time (ms)</th>
			<th>Requested By</th>
			<th>Date Requested</th>
		</tr>
	</thead>
	</table>
        
    <?php
    die();
}



add_action('wp_ajax_nopriv_pgcsform_handler','pgcsformhandler');
add_action('wp_ajax_pgcsform_handler','pgcsformhandler');
function pgcsformhandler(){
    
    $time = microtime();
    $time = explode(' ', $time);
    $time = $time[1] + $time[0];
    $start = $time;   
    
    $pathinfo = wp_upload_dir();
    $dir_name = time();
    $_newpath = $pathinfo['basedir'].'/pgsc_tempfiles/'.$dir_name;
    mkdir($_newpath,0755);
    $i =  0 ;
    $array = array();
    $agent_fixer = 0;
    $limit  = spinPermutation($_POST['article'],false,true);
    $limit = (int)$_POST['limit_output'] <= $limit ? (int)$_POST['limit_output'] : $limit;
    while( $i < $limit  ){
     $str =  getSpinned($_POST['article']);
     
     if( empty($array) || !in_array($str,$array ) ){
        $filename = $_newpath.'/'.get_option('pgsc_form_files_file_prefix').'-'.str_pad($i + 1 ,strlen(get_option('pgsc_system_max_output') - 1),0,STR_PAD_LEFT).'.txt';
        $fp = fopen($filename, 'w+');
        fwrite($fp, $str);
        fclose($fp);  
        $i++; 
        $array[] = $str;
        $files[] = $filename;
       
     }else{
         continue;
     }
     
    }
    if( !class_exists('PclZip') ) include  PG_CONTENTSPINNER_PLUGIN_DIR."libraries/pclzip.lib.php";
    $archive = new PclZip($_newpath.'.zip');
    $v_list = $archive->create(implode(',',$files),
                                PCLZIP_OPT_REMOVE_PATH,  $_newpath,
                                PCLZIP_OPT_ADD_PATH, 'spun-articles');
    
    if ($v_list == 0) {
        //die("Error : ".$archive->errorInfo(true));
        $download_link = "Process Error : Unable to compressed the following files ".implode(',',$files);
    }else{
        pgcsRmdirRecursive($_newpath);
        $download_link = $pathinfo['baseurl'].'/pgsc_tempfiles/'.$dir_name.'.zip';
    }
    
    $time = microtime();
    $time = explode(' ', $time);
    $time = $time[1] + $time[0];
    $finish = $time;
    $total_time = round(($finish - $start), 4);	
    
    
    if((int)get_option('pgsc_system_save_articles') == 1 && $_POST['mode'] !="admin") {
      global $wpdb; 
      $wpdb->insert($wpdb->prefix."pgcs_saved_articles",array('original' => $_POST['article'], 'spinned' => json_encode($array) ,'date_created' => time(), 'process_time' => $total_time,'remote_addr' => $_SERVER['REMOTE_ADDR'] ));
    }
    die( $download_link );
}

add_action('init','pgcs_housekeeping');

function pgcs_housekeeping(){
  $pathinfo = wp_upload_dir();   
 if(!is_dir($pathinfo['basedir'].'/pgsc_tempfiles/')) mkdir($pathinfo['basedir'].'/pgsc_tempfiles',0755);    
$pathinfo = wp_upload_dir();
$checkpath = $pathinfo['basedir'].'/pgsc_tempfiles/';
$_dir = @scandir($checkpath);
if(empty($_dir)) return;
    foreach($_dir as $file) {
        if ('.' === $file || '..' === $file) continue;   
        $dir_ts = basename($file,'.zip');
            if($dir_ts <= strtotime((string)get_option('pgsc_system_delzip_timestamp')) ) @unlink($checkpath.$file);
    }
}

include "functions.php";

?>